<!DOCTYPE html>
<html lang="vi">
<head>
    <!--=========================================== FONT ======================================-->
    <link href="https://fonts.googleapis.com/css?family=Roboto:400,300,500,700,100&amp;subset=latin,vietnamese"
          rel="stylesheet" type="text/css">
    <link rel="stylesheet" href="css/bootstrap.min.css">
    <link rel="stylesheet" href="css/MDBootstrap_pro.min.css">
    <link rel="stylesheet" href="css/font-awesome.min.css">

    <style>
        #page {
            padding: 20px;
            color: #333;
            min-height: 100vh;
        }

        .panel {
            margin-bottom: 20px;
        }

        .panel-heading {
            position: relative;
            border: 1px solid #b9b9b9;
            border-radius: 4px 4px 0 0;
            height: 40px;
            line-height: 40px;
            padding-left: 120px;
            overflow: hidden;
            box-sizing: content-box;
        }

        .panel-heading .btn-show {
            position: absolute;
            top: 0;
            left: -2px;
            height: 40px;
            width: 100px;
            margin: 0;
            box-shadow: none;
            border: none;
            background: #639eff;
            color: #fff;
            border-radius: 4px 0 0 4px;
            box-sizing: border-box;
            cursor: pointer;
        }

        .panel-heading .content {
            width: 30%;
            float: left;
            font-weight: bold;
        }

        .panel-heading .brief {
            float: right;
            text-align: right;
            padding-right: 20px;
        }

        .panel-body {
            border: 1px solid #b9b9b9;
            border-top: none;
            padding: 20px 30px;
        }

        .panel-child .panel-heading {
            padding-left: 30px;
            font-weight: bold;
            cursor: pointer;
            background: #e6f9fb;
            color: #000;
            border: 1px solid #bff0f5;
        }

        .list-group {
            margin-bottom: 4px !important;
        }

        .method-info-title {
            font-size: 18px;
            color: #00c1d5;
            margin: 5px;
        }

        .sample {
            display: none;
        }

        .label {
            font-weight: bold;
        }

    </style>
</head>

<body>
<div id="page" class="page-remote_api">
    <div class="wrapper">
        <div id="page-body">
            <div class="service-panel sample">
                <h3 class="service-name">authen</h3>
                <div>
                    <p style="margin: 0px">HOST: <span class="domain" style="font-weight: bold">ketnoitienganh.com</span></p>
                    <p>PORT: <span class="port" style="font-weight: bold">23456</span></p>
                </div>

                <div class="panel model-panel sample">
                    <div class="panel-heading">
                        <button class="btn-show" data-toggle="collapse" data-target="#">authen</button>
                        <div class="content"></div>
                        <div class="brief">
                            authen for multi service
                        </div>
                        <div class="clearfix"></div>
                    </div>

                    <div class="collapse panel-body" id="">
                        <div class="panel panel-primary panel-child sample">
                            <div class="panel-heading" data-toggle="collapse" data-target="#">
                                getToken
                            </div>
                            <div class="panel-body collapse" id="">
                                <p class="method-info-title label"><strong>Call</strong></p>
                                <div style="margin-left: 20px">
                                    <span class="method-sign label">authen.getToken</span>
                                </div>

                                <p class="method-info-title label">Description</p>
                                <div style="margin-left: 20px">
                                    <span class="method-des"></span>
                                </div>

                                <p class="method-info-title label">Params</p>
                                <div style="margin-left: 20px" class="params">
                                    <!--<p><span class="label">userId</span>: <span>string</span></p>-->
                                </div>

                                <p class="method-info-title label">Returns</p>
                                <div style="margin-left: 20px" class="returns">
                                    <!--<p><span><strong>error</strong></span>: <span>object</span></p>-->
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div id="popup-or-other">
    </div>
</div>

<!-- ================================================== SCRIPT ================================== -->

<script src="js/jquery.min.js"></script>
<script src="js/tether.min.js"></script>
<script src="js/bootstrap.min.js"></script>
<script src="js/mdb.min.js"></script>

<script>
    function postHttp(path, data, callback) {
        if (data.param) {
            data.param = JSON.stringify(data.param);
        }
        $.ajax({
            url: path,
            type: 'POST',
            data: data,
            success: function (rsl) {
                callback(rsl);
            },
            dataType: 'json',
            complete: function () {

            }
        });
    }

    function renderServiceMethods(serviceId, apis, configs) {
        var newItem = $('.service-panel.sample').clone().removeClass('sample').appendTo('#page-body')
        newItem.find('.service-name').html(serviceId);
        newItem.find('.domain').html(configs.domain);
        newItem.find('.port').html(configs.port);

        for(var modelName in apis) {
            var modelInfo = apis[modelName];
            var newModelItem = newItem.find('.model-panel.sample').clone().removeClass('sample').appendTo(newItem);
            newModelItem.find('.panel-heading .btn-show').attr('data-target', '#' + modelName).html(modelName);
            newModelItem.find('.brief').html(modelInfo.description);
            newModelItem.find('.panel-body').attr('id', modelName);

            var methods = modelInfo.methods || [];
            for(var i = 0; i < methods.length; i ++) {
                var method = methods[i];
                var newMethodItem = newModelItem.find('.panel-child.sample').clone().removeClass('sample')
                    .appendTo(newModelItem.children('.panel-body'))
                newMethodItem.find('.panel-heading').attr('data-target', '#' + modelName + '-' + method.name).html(method.name);
                newMethodItem.find('.panel-body').attr('id', modelName + '-' + method.name);
                newMethodItem.find('.method-sign').html(modelName + '.' + method.name);
                newMethodItem.find('.method-des').html(method.description);

                for(var j = 0; j < method.params.length; j ++) {
                    var param = method.params[j];
                    newMethodItem.find('.params').append('<p><span class="label">' + (param.arg || param) + '</span>: <span>' + (param.type || '') + '</span></p>')
                }

                for(var j = 0; j < method.returns.length; j ++) {
                    var response = method.returns[j];
                    newMethodItem.find('.returns').append('<p><span class="label">' + response.arg + '</span>: <span>' + response.type + '</span></p>')
                }
            }
        }
    }

    postHttp('', {}, function (rsl) {
        if(rsl) {
            var apis = rsl.apis;
            for(var serviceId in apis) {
                var info = apis[serviceId];
                renderServiceMethods(serviceId, info, rsl.configs[serviceId]);
            }
        }
    })


</script>
</body>
</html>